"use strict";
/* eslint-disable no-unused-vars */
document.addEventListener("DOMContentLoaded", function (event) {
    let WrapperElementId;
    (function (WrapperElementId) {
        WrapperElementId["NUMBER"] = "card-number";
        WrapperElementId["DATE"] = "card-date";
        WrapperElementId["CVV"] = "card-cvv";
        WrapperElementId["ZIP"] = "card-postal-code";
    })(WrapperElementId || (WrapperElementId = {}));
    let ErrorDisplayElementId;
    (function (ErrorDisplayElementId) {
        ErrorDisplayElementId["NUMBER"] = "card-number-errors";
        ErrorDisplayElementId["DATE"] = "card-date-errors";
        ErrorDisplayElementId["CVV"] = "card-cvv-errors";
        ErrorDisplayElementId["ZIP"] = "card-postal-code-errors";
    })(ErrorDisplayElementId || (ErrorDisplayElementId = {}));
    // WooCommerce name attribute on the Form that includes our gateway and its inputs
    let FormName;
    (function (FormName) {
        FormName["CHECKOUT"] = "checkout";
        FormName["ORDER_PAY"] = "order_review";
    })(FormName || (FormName = {}));
    class Settings {
        constructor(pakms, locale) {
            this.pakms = pakms;
            this.locale = locale;
        }
    }
    let CloverElementType;
    (function (CloverElementType) {
        CloverElementType["CARD"] = "CARD";
        CloverElementType["CVV"] = "CARD_CVV";
        CloverElementType["DATE"] = "CARD_DATE";
        CloverElementType["NUMBER"] = "CARD_NUMBER";
        CloverElementType["POSTAL_CODE"] = "CARD_POSTAL_CODE";
        CloverElementType["STREET_ADDRESS"] = "CARD_STREET_ADDRESS";
        CloverElementType["PAYMENT_REQUEST_BUTTON"] = "PAYMENT_REQUEST_BUTTON";
    })(CloverElementType || (CloverElementType = {}));
    // Styling
    let cvvInputPlaceHolder = {};
    if (window.WeeConnectPayPaymentFieldsData.locale === 'fr-CA') {
        // fr-CA wraps the line, so we need to push it higher
        cvvInputPlaceHolder = {
            whiteSpace: 'pre-line',
            position: 'relative',
            top: '-7px',
        };
    }
    else {
        // We don't need to wrap up the line higher since it sits on one line
        cvvInputPlaceHolder = {};
    }
    // For browser security, the scope of the CSS is limited to the instance of the element created inside the iframe.
    const styles = {
        'card-number input': {
            border: '1px #C8C8C8 solid',
            borderRadius: '3px',
            textIndent: '1em',
        },
        'card-date input': {
            border: '1px #C8C8C8 solid',
            borderRadius: '3px',
            textAlign: 'center'
        },
        'card-cvv input': {
            border: '1px #C8C8C8 solid',
            borderRadius: '3px',
            textAlign: 'center'
        },
        'card-postal-code input': {
            border: '1px #C8C8C8 solid',
            borderRadius: '3px',
            textAlign: 'center'
        },
        'input': {
            // Fixes for https://community.clover.com/questions/24714/issue-in-clover-hosted-iframe-application-running.html
            padding: '0px',
            margin: '0px',
            height: '3.4em',
            width: '100%',
        },
        '::-webkit-input-placeholder': {
            textAlign: 'center',
        },
        'card-number input::-webkit-input-placeholder': {
            textAlign: 'inherit',
        },
        'card-cvv input::-webkit-input-placeholder': cvvInputPlaceHolder,
    };
    //
    // const targetNode = document.querySelector('body');
    //
    // const config = {
    //     attributes: true,
    //     childList: true,
    //     characterData: true
    // };
    //
    // // @ts-ignore
    // const callback = mutations => {
    //     // @ts-ignore
    //     mutations.forEach(mutation => {
    //         console.log('targetNode mutated:', targetNode);
    //         if (mutation.type === 'childList') {
    //             // @ts-ignore
    //             const listValues = Array.from(targetNode.children)
    //                 .map(node => node.innerHTML)
    //                 .filter(html => html !== '<br>');
    //             console.log(listValues);
    //         }
    //     });
    // }
    //
    // const observer = new MutationObserver(callback);
    //
    // // @ts-ignore
    // observer.observe(targetNode, config);
    // // Find out what form element it is
    // // Select the checkout form only available in checkout
    // let currentWooCommerceForm: CurrentFormElement;
    //
    // // Find forms in page and get an HTMLCollection back
    // // eslint-disable-next-line no-undef
    // const formCollection: HTMLCollectionOf<HTMLFormElement> = document.forms;
    //
    // const getCurrentWooCommerceForm: () => (HTMLFormElement) = function () {
    //     console.debug(`Looking for form name: ${FormName.CHECKOUT} :`,formCollection.namedItem(FormName.CHECKOUT));
    //     console.debug(`Looking for form name: ${FormName.ORDER_PAY} :`,formCollection.namedItem(FormName.ORDER_PAY));
    //
    //     setTimeout(function () {
    //         console.debug(`In SetTimeout - Looking for form name: ${FormName.CHECKOUT} :`,formCollection.namedItem(FormName.CHECKOUT));
    //         console.debug(`In SetTimeout - Looking for form name: ${FormName.ORDER_PAY} :`,formCollection.namedItem(FormName.ORDER_PAY));
    //
    //     }, 2000);
    //
    //     if (formCollection.namedItem(FormName.CHECKOUT) && !formCollection.namedItem(FormName.ORDER_PAY)) {
    //         const formGuess: null | Element = formCollection.namedItem(FormName.CHECKOUT);
    //         if (formGuess instanceof HTMLFormElement) {
    //             return formGuess;
    //         } else {
    //             throw Error('Unable to find form');
    //         }
    //     } else if (!formCollection.namedItem(FormName.CHECKOUT) && formCollection.namedItem(FormName.ORDER_PAY)) {
    //         const formGuess: null | Element = formCollection.namedItem(FormName.ORDER_PAY);
    //         if (formGuess instanceof HTMLFormElement) {
    //             return formGuess;
    //         } else {
    //             throw Error('Unable to find form');
    //         }
    //     } else {
    //         console.log('Form Collection: ',formCollection)
    //         throw Error('Unable to find form',);
    //     }
    // };
    //
    // currentWooCommerceForm = getCurrentWooCommerceForm();
    const convertSettings = () => {
        return new Settings(window.WeeConnectPayPaymentFieldsData.pakms, window.WeeConnectPayPaymentFieldsData.locale);
    };
    let settings = convertSettings();
    const clover = new window.Clover(settings.pakms);
    // @ts-ignore
    clover.options = {
        locale: settings.locale,
        // merchantId: "SK36FZYP2ZKJ1",
        // @ts-ignore
        // showSecurePayments: false,
        // @ts-ignore
        // showPrivacyPolicy:  false,
    };
    const elements = clover.elements();
    const cardNumber = elements.create(CloverElementType.NUMBER, styles);
    const cardDate = elements.create(CloverElementType.DATE, styles);
    const cardCvv = elements.create(CloverElementType.CVV, styles);
    const cardPostalCode = elements.create(CloverElementType.POSTAL_CODE, styles);
    const mountFields = (cardNumber, cardDate, cardCvv, cardPostalCode) => {
        cardNumber.mount('#' + WrapperElementId.NUMBER);
        cardDate.mount('#' + WrapperElementId.DATE);
        cardCvv.mount('#' + WrapperElementId.CVV);
        cardPostalCode.mount('#' + WrapperElementId.ZIP);
    };
    // Client Side Validation
    const cardResponse = document.getElementById('card-response');
    const displayCardNumberError = document.getElementById('card-number-errors');
    const displayCardDateError = document.getElementById('card-date-errors');
    const displayCardCvvError = document.getElementById('card-cvv-errors');
    const displayCardPostalCodeError = document.getElementById('card-postal-code-errors');
    let checkoutForm = document.querySelector('form.checkout');
    let paymentMethod = document.querySelector('input[name="payment_method"]:checked');
    let orderPayForm = document.querySelector('form#order_review');
    const addError = (wrapperElement, errorDisplayElement, errorText) => {
        errorDisplayElement.textContent = errorText;
        errorDisplayElement.classList.add('error');
        wrapperElement.classList.remove('success');
        wrapperElement.classList.add('error');
    };
    const removeError = (wrapperElement, errorDisplayElement) => {
        errorDisplayElement.textContent = null;
        errorDisplayElement.classList.remove('error');
        wrapperElement.classList.remove('error');
        wrapperElement.classList.add('success');
    };
    const initListeners = (checkoutForm, paymentMethod, orderPayForm) => {
        // Handle real-time validation errors from the card element
        cardNumber.addEventListener('change', function (event) {
            let displayError = document.getElementById(ErrorDisplayElementId.NUMBER);
            let wrapperElement = document.getElementById(WrapperElementId.NUMBER);
            if (displayError && wrapperElement) {
                // @ts-ignore
                if (event.CARD_NUMBER.error) {
                    // @ts-ignore
                    addError(wrapperElement, displayError, event.CARD_NUMBER.error);
                }
                else {
                    removeError(wrapperElement, displayError);
                }
            }
        });
        cardNumber.addEventListener('blur', function (event) {
            let displayError = document.getElementById(ErrorDisplayElementId.NUMBER);
            let wrapperElement = document.getElementById(WrapperElementId.NUMBER);
            if (displayError && wrapperElement) {
                // @ts-ignore
                if (event.CARD_NUMBER.error) {
                    // @ts-ignore
                    addError(wrapperElement, displayError, event.CARD_NUMBER.error);
                }
                else {
                    removeError(wrapperElement, displayError);
                }
            }
        });
        cardDate.addEventListener('change', function (event) {
            let displayError = document.getElementById(ErrorDisplayElementId.DATE);
            let wrapperElement = document.getElementById(WrapperElementId.DATE);
            if (displayError && wrapperElement) {
                // @ts-ignore
                if (event.CARD_DATE.error) {
                    // @ts-ignore
                    addError(wrapperElement, displayError, event.CARD_DATE.error);
                }
                else {
                    removeError(wrapperElement, displayError);
                }
            }
        });
        cardDate.addEventListener('blur', function (event) {
            let displayError = document.getElementById(ErrorDisplayElementId.DATE);
            let wrapperElement = document.getElementById(WrapperElementId.DATE);
            if (displayError && wrapperElement) {
                // @ts-ignore
                if (event.CARD_DATE.error) {
                    // @ts-ignore
                    addError(wrapperElement, displayError, event.CARD_DATE.error);
                }
                else {
                    removeError(wrapperElement, displayError);
                }
            }
        });
        cardCvv.addEventListener('change', function (event) {
            let displayError = document.getElementById(ErrorDisplayElementId.CVV);
            let wrapperElement = document.getElementById(WrapperElementId.CVV);
            if (displayError && wrapperElement) {
                // @ts-ignore
                if (event.CARD_CVV.error) {
                    // @ts-ignore
                    addError(wrapperElement, displayError, event.CARD_CVV.error);
                }
                else {
                    removeError(wrapperElement, displayError);
                }
            }
        });
        cardCvv.addEventListener('blur', function (event) {
            let displayError = document.getElementById(ErrorDisplayElementId.CVV);
            let wrapperElement = document.getElementById(WrapperElementId.CVV);
            if (displayError && wrapperElement) {
                // @ts-ignore
                if (event.CARD_CVV.error) {
                    // @ts-ignore
                    addError(wrapperElement, displayError, event.CARD_CVV.error);
                }
                else {
                    removeError(wrapperElement, displayError);
                }
            }
        });
        cardPostalCode.addEventListener('change', function (event) {
            let displayError = document.getElementById(ErrorDisplayElementId.ZIP);
            let wrapperElement = document.getElementById(WrapperElementId.ZIP);
            if (displayError && wrapperElement) {
                // @ts-ignore
                if (event.CARD_POSTAL_CODE.error) {
                    // @ts-ignore
                    addError(wrapperElement, displayError, event.CARD_POSTAL_CODE.error);
                }
                else {
                    removeError(wrapperElement, displayError);
                }
            }
        });
        cardPostalCode.addEventListener('blur', function (event) {
            let displayError = document.getElementById(ErrorDisplayElementId.ZIP);
            let wrapperElement = document.getElementById(WrapperElementId.ZIP);
            if (displayError && wrapperElement) {
                // @ts-ignore
                if (event.CARD_POSTAL_CODE.error) {
                    // @ts-ignore
                    addError(wrapperElement, displayError, event.CARD_POSTAL_CODE.error);
                }
                else {
                    removeError(wrapperElement, displayError);
                }
            }
        });
        // Payment processing
        if (checkoutForm) {
            let jQueryCheckoutForm = jQuery('form.checkout');
            jQueryCheckoutForm.on('checkout_place_order', function (event) {
                let jQueryPaymentMethod = jQuery('input[name="payment_method"]:checked').val();
                if (jQueryPaymentMethod === 'weeconnectpay') {
                    let token = document.querySelector('#wcp-token');
                    if (token && token.value === '') {
                        event.preventDefault();
                    }
                    else {
                        return true;
                    }
                    // Use the iframe's tokenization method with the user-entered card details
                    clover.createToken()
                        .then(function (result) {
                        if (result.errors) {
                            handleTokenCreationErrors(result);
                        }
                        else if (result.token) {
                            cloverTokenHandler(result.token);
                            jQueryCheckoutForm.trigger('submit');
                        }
                        else {
                            throw new Error('Something went wrong tokenizing the card. Payment will not be processed.');
                        }
                    });
                }
                else {
                    return true;
                }
                return false;
            });
        }
        else if (orderPayForm) {
            let jQueryOrderPayForm = jQuery('form#order_review');
            jQueryOrderPayForm.on('submit', function (event) {
                let jQueryPaymentMethod = jQuery('input[name="payment_method"]:checked').val();
                if (jQueryPaymentMethod === 'weeconnectpay') {
                    let token = document.querySelector('#wcp-token');
                    if (token && token.value === '') {
                        event.preventDefault();
                    }
                    else {
                        return true;
                    }
                    // Use the iframe's tokenization method with the user-entered card details
                    clover.createToken()
                        .then(function (result) {
                        if (result.errors) {
                            handleTokenCreationErrors(result);
                        }
                        else if (result.token) {
                            cloverTokenHandler(result.token);
                            jQueryOrderPayForm.trigger('submit');
                        }
                        else {
                            throw new Error('Something went wrong tokenizing the card. Payment will not be processed.');
                        }
                    });
                }
                else {
                    return true;
                }
                return false;
            });
        }
        else {
            throw new Error('Could not find an appropriate payment form.');
        }
    };
    const handleTokenCreationErrors = (result) => {
        if (result.errors) {
            // Number
            if (result.errors.CARD_NUMBER) {
                let displayNumberError = document.getElementById(ErrorDisplayElementId.NUMBER);
                let wrapperNumberElement = document.getElementById(WrapperElementId.NUMBER);
                if (displayNumberError && wrapperNumberElement) {
                    addError(wrapperNumberElement, displayNumberError, result.errors.CARD_NUMBER);
                }
            }
            // Date
            if (result.errors.CARD_DATE) {
                let displayDateError = document.getElementById(ErrorDisplayElementId.DATE);
                let wrapperDateElement = document.getElementById(WrapperElementId.DATE);
                if (displayDateError && wrapperDateElement) {
                    addError(wrapperDateElement, displayDateError, result.errors.CARD_DATE);
                }
            }
            // CVV
            if (result.errors.CARD_CVV) {
                let displayCvvError = document.getElementById(ErrorDisplayElementId.CVV);
                let wrapperCvvElement = document.getElementById(WrapperElementId.CVV);
                if (displayCvvError && wrapperCvvElement) {
                    addError(wrapperCvvElement, displayCvvError, result.errors.CARD_CVV);
                }
            }
            // POSTAL_CODE
            if (result.errors.CARD_POSTAL_CODE) {
                let displayPostalCodeError = document.getElementById(ErrorDisplayElementId.ZIP);
                let wrapperPostalCodeElement = document.getElementById(WrapperElementId.ZIP);
                if (displayPostalCodeError && wrapperPostalCodeElement) {
                    addError(wrapperPostalCodeElement, displayPostalCodeError, result.errors.CARD_POSTAL_CODE);
                }
            }
        }
    };
    function cloverTokenHandler(token) {
        // Insert the token ID into the form so it gets submitted to the server
        let hiddenInput = document.querySelector('#wcp-token');
        if (!hiddenInput) {
            throw new Error('Token field is missing!');
        }
        if (hiddenInput.value === '') {
            hiddenInput.value = token;
            return false;
        }
        else {
            return true;
        }
    }
    if (checkoutForm) {
        // Because WooCommerce is a special little snowflake that doesn't care about not using outdated libraries
        jQuery(document.body).on('updated_checkout', function () {
            let cardWrapperElement = document.getElementById(WrapperElementId.NUMBER);
            if (!cardWrapperElement) {
                console.error('Could not find the element to insert the iframe into.');
                return;
            }
            if (cardWrapperElement && cardWrapperElement.children.length) {
                // Iframe is already loaded
                return;
            }
            mountFields(cardNumber, cardDate, cardCvv, cardPostalCode);
            initListeners(checkoutForm, paymentMethod, orderPayForm);
        });
    }
    else {
        if (jQuery("form#add_payment_method").length || jQuery("form#order_review").length) {
            mountFields(cardNumber, cardDate, cardCvv, cardPostalCode);
            initListeners(checkoutForm, paymentMethod, orderPayForm);
        }
    }
});
