<?php

namespace WeeConnectPay\Api\Requests;

use WeeConnectPay\Dependencies\GuzzleHttp\Exception\GuzzleException;
use WeeConnectPay\Dependencies\Psr\Http\Message\ResponseInterface;
use WeeConnectPay\Api\ApiClient;
use WeeConnectPay\Api\ApiEndpoints;
use WeeConnectPay\WordPress\Plugin\includes\WeeConnectPayUtilities;

class CreateCloverOrderChargeRequest extends ApiClient {

	/**
	 * POST request
	 */
	public function POST(string $cloverOrderUuid, string $tokenizedCard): ResponseInterface {
		return $this->client->post( ApiEndpoints::createOrderCharge($cloverOrderUuid), self::setOptions($tokenizedCard));
	}

	private static function setOptions(string $tokenizedCard): array {
		$options['form_params'] = self::setRequestBody( $tokenizedCard );

		return $options;
	}

	/**
	 * Set the request body
	 *
	 * @param string $tokenizedCard
	 *
	 * @return array
	 */
	private static function setRequestBody(string $tokenizedCard): array {

		return [
			'tokenized_card' => $tokenizedCard
		];
	}
}
