<?php

//phpcs:disable WordPress
//phpcs:disable Generic.Arrays.DisallowShortArraySyntax
namespace WeeConnectPay;

class StandardizedResponse {

	public static function emitSuccess( object $data ): object {
		return self::emit( $data, 'success' );
	}

	public static function emitError( object $data ): object {
		return self::emit( $data, 'error' );
	}

	public static function emit( object $data, string $type = 'error' ): object {
		return (object) [
			'result' => $type,
			'data'   => self::emitData( $data, $type )
		];

	}

	public static function emitData( object $data, string $type ) {
		if ( $type !== 'success' ) {
			$message = $data->message ?? __( 'A malformed response was received. Our team has been notified. We are sorry for the inconvenience.' );

			return [
				'error' => [
					'message' => $message
				]
			];
		} else {
			return $data;
		}
	}
}
